#ifndef MCHEXAHANDLERFACTORYIMPL_H_
#define MCHEXAHANDLERFACTORYIMPL_H_

#include <mchexahandlerimpl.h>
#include <org.sipesc.fems.hexaelement.mchexahandlerfactory.h>
using namespace org::sipesc::fems::hexaelement;

class MCHEXAHandlerFactoryImpl: public MCHEXAHandlerFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MCHEXAHandlerFactoryImpl()
      {
      }

    QList<QVariant> getTypes() const
      {
      QList<QVariant> list;
      list << "CHEXA"; //好好看看,好好理解一下！这个不是随便写的
      return list;
      }

    QString getDescription() const
      {
      return "factory for MCHEXAHandler";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * 创建任务对象
     */
    MExtension createExtension(const QVariant& key) const //内部结构需好好研究研究！
      {
      MCHEXAHandlerImpl *p = new MCHEXAHandlerImpl;
      return MCHEXAHandler(p);
      }
  };

#endif /* MCHEXAHANDLERFACTORYIMPL_H_ */
