#ifndef MCHEXAHANDLERIMPL_H_
#define MCHEXAHANDLERIMPL_H_

#include <memory>
#include <org.sipesc.core.utility.progressmonitor.h>
#include <org.sipesc.core.engdbs.data.mdatamodel.h>
#include <org.sipesc.fems.bdfimport.mbdfentryreader.h>
#include <org.sipesc.fems.hexaelement.mchexahandler.h>
using namespace org::sipesc::core::utility;
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::fems::bdfimport;
using namespace org::sipesc::fems::hexaelement;

class MCHEXAHandlerImpl: public MCHEXAHandlerInterface
  {
  public:
    MCHEXAHandlerImpl();
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MCHEXAHandlerImpl();

  public:
    /**
     * 初始化:
     */
    bool initialize(MDataModel& model, bool isRepeated);

    ProgressMonitor getProgressMonitor() const;

    bool handleEntry(const MBdfEntryReader& reader);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MCHEXAHANDLERIMPL_H_ */
