/*
 * mgau3dintegformfactoryimpl.h
 *
 *  Created on: 2014年11月20日
 *      Author: steven
 */

#ifndef MGAU3DINTEGFORMFACTORYIMPL_H_
#define MGAU3DINTEGFORMFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mgau3dintegformimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mgau3dintegformfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MGau3DIntegFormFactoryImpl: public MGau3DIntegFormFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGau3DIntegFormFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList<QVariant> list;
      list << "Gau3DIntegration";
      return list;
      }

    QString getDescription() const
      {
      return "factory for MGau3DIntegForm";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MGau3DIntegFormImpl* p = new MGau3DIntegFormImpl;
      return MGau3DIntegForm(p);
      }
  };

#endif /* MGAU3DINTEGFORMFACTORYIMPL_H_ */
