#ifndef MGHEXABRICKNODESTRESSCALCULATORIMPL_H
#define MGHEXABRICKNODESTRESSCALCULATORIMPL_H


#include <memory>
#include <org.sipesc.core.engdbs.data.mdataobject.h>
#include <org.sipesc.fems.hexaelement.mghexabricknodestresscalculator.h>
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::fems::hexaelement;

class MGHexaBrickNodeStressCalculatorImpl: public MGHexaBrickNodeStressCalculatorInterface
  {
  public:
    MGHexaBrickNodeStressCalculatorImpl();
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGHexaBrickNodeStressCalculatorImpl();
    /**
     * to get strain matrix
     *
     * @param integ data which stores parameter coordinate of integral point
     * @return strain matrix
     */
    MDataObject getNodeStress(const MDataObject& integStressData);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MGHEXABRICKNODESTRESSCALCULATORIMPL_H */
