/*
 * mhexabrickelementdataimpl.h
 *
 *  Created on: 2013-6-8
 *      Author: steven
 */

#ifndef MHEXABRICKELEMENTDATAIMPL_H_
#define MHEXABRICKELEMENTDATAIMPL_H_

#include <melementdataimpl.h>
#include <org.sipesc.core.engdbs.data.mdatafactory.h>
using namespace org::sipesc::core::engdbs::data;

const QUuid MHexaBrickElementDataUuid =
    "4b8699f2-e491-4a45-8d53-cfd95ddc570e";

class MHexaBrickElementDataImpl: public MElementDataImpl
  {
  public:
    MHexaBrickElementDataImpl();
    virtual ~MHexaBrickElementDataImpl();

  public:
    QString getType() const;
    QList<int> getActiveDofs(int);

  public:
    QUuid getTypeId() const
      {
      return MHexaBrickElementDataUuid;
      }

  private:
    int _node8Id[8];
  };

class MHexaBrickElementDataFactoryImpl: public MDataFactoryInterface
  {
  public:
    MHexaBrickElementDataFactoryImpl();
    virtual ~MHexaBrickElementDataFactoryImpl()
      {
      }

  public:
    QUuid getTypeId() const
      {
      return MHexaBrickElementDataUuid;
      }
    MDataObject createObject() const;
    int supportedType(const QUuid&) const;
  };

#endif /* MHEXABRICKELEMENTDATAIMPL_H_ */
