#ifndef MHEXABRICKELEVOLUMEFACTORYIMPL_H_
#define MHEXABRICKELEVOLUMEFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mhexabrickelevolumeimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mhexabrickelevolumefactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickEleVolumeFactoryImpl: public MHexaBrickEleVolumeFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MHexaBrickEleVolumeFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList < QVariant > list;
      list << global.getValue(MElementsGlobal::HexaBrickElement)
          << "Hexa185BrickElement";
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickEleVolume";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MHexaBrickEleVolumeImpl* p = new MHexaBrickEleVolumeImpl;
      return MHexaBrickEleVolume(p);
      }
  };

#endif /* MHEXABRICKELEVOLUMEFACTORYIMPL_H_ */
