#ifndef MUNVHEXABRICKELEDATAEXPORTORFACTORYIMPL_H_
#define MUNVHEXABRICKELEDATAEXPORTORFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <munvhexabrickeledataexportorimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.munvhexabrickeledataexportorfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MUnvHexaBrickEleDataExportorFactoryImpl: public MUnvHexaBrickEleDataExportorFactoryInterface
  {
  public:
    /*
     * 析构函数，仅为类继承关系而设置
     */
    virtual ~MUnvHexaBrickEleDataExportorFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList < QVariant > list;
      list << global.getValue(MElementsGlobal::HexaBrickElement)
          << "Hexa185BrickElement";
      return list;
      }

    QString getDescription() const
      {
      return "factory for MUnvHexaBrickEleDataExportor";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MUnvHexaBrickEleDataExportorImpl* p =
          new MUnvHexaBrickEleDataExportorImpl;
      return MUnvHexaBrickEleDataExportor(p);
      }
  };

#endif /* MUNVHEXABRICKELEDATAEXPORTORFACTORYIMPL_H_ */
