/*
 * mhexabrickelementdataimpl.cxx
 *
 *  Created on: 2013-6-8
 *      Author: steven
 */

#include <mhexabrickelementdataimpl.h>
#include <mobjectmanager.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.data.melementactivedofs.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::data;

MHexaBrickElementDataImpl::MHexaBrickElementDataImpl()
  {
  _propertyId = 0;
  _number = 8;
  _nodeId = _node8Id;
  }

MHexaBrickElementDataImpl::~MHexaBrickElementDataImpl()
  {
  }

QString MHexaBrickElementDataImpl::getType() const
  {
  MObjectManager manager = MObjectManager::getManager();
  MElementsGlobal global = manager.getObject(
      "org.sipesc.fems.global.elementsglobal");

  return global.getValue(MElementsGlobal::HexaBrickElement);
  }

QList<int> MHexaBrickElementDataImpl::getActiveDofs(int index)
  {
  MObjectManager manager = MObjectManager::getManager();
  MElementActiveDofs dof = manager.getObject(
      "org.sipesc.fems.data.elementactivedofs");

  return dof.getActiveDofs(MElementActiveDofs::MBrick);
  }

// =========================================================================
MHexaBrickElementDataFactoryImpl::MHexaBrickElementDataFactoryImpl()
  {
  }

MDataObject MHexaBrickElementDataFactoryImpl::createObject() const
  {
  return MDataObject(new MHexaBrickElementDataImpl);
  }

int MHexaBrickElementDataFactoryImpl::supportedType(
    const QUuid& typeId) const
  {
  bool is = (typeId == MHexaBrickElementDataUuid);
  return is ? 1 : 0;
  }
