#ifndef MHEXABRICKLUMPEDMASSMATRIXFACTORYIMPL_H_
#define MHEXABRICKLUMPEDMASSMATRIXFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mhexabricklumpedmassmatriximpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mhexabricklumpedmassmatrixfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickLumpedMassMatrixFactoryImpl: public MHexaBrickLumpedMassMatrixFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MHexaBrickLumpedMassMatrixFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList<QVariant> list;
      list << global.getValue(MElementsGlobal::LumpedMass);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickLumpedMassMatrix";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MHexaBrickLumpedMassMatrixImpl* p = new MHexaBrickLumpedMassMatrixImpl;
      return MHexaBrickLumpedMassMatrix(p);
      }
  };

#endif /* MHEXABRICKLUMPEDMASSMATRIXFACTORYIMPL_H_ */
