#ifndef MHEXABRICKSTRAINMATRIXFACTORYIMPL_H_
#define MHEXABRICKSTRAINMATRIXFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mhexabrickstrainmatriximpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mhexabrickstrainmatrixfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickStrainMatrixFactoryImpl: public MHexaBrickStrainMatrixFactoryInterface
  {
  public:
    /*
     * 析构函数，仅为类继承关系而设置
     */
    ~MHexaBrickStrainMatrixFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList < QVariant > list;
      list << global.getValue(MElementsGlobal::HexaBrickStrainMatrix)
          << global.getValue(MElementsGlobal::HexaBrickElement);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickStrainMatrix";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MHexaBrickStrainMatrixImpl* p = new MHexaBrickStrainMatrixImpl;
      return MHexaBrickStrainMatrix(p);
      }
  };

#endif /* MHEXABRICKSTRAINMATRIXFACTORYIMPL_H_ */
