#ifndef MUNVHEXABRICKELEDATAEXPORTORIMPL_H_
#define MUNVHEXABRICKELEDATAEXPORTORIMPL_H_

#include <memory>
#include <qtextstream.h>
#include <org.sipesc.core.utility.progressmonitor.h>
#include <org.sipesc.core.engdbs.data.mdatamodel.h>
#include <org.sipesc.fems.hexaelement.munvhexabrickeledataexportor.h>
using namespace org::sipesc::core::utility;
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::fems::hexaelement;

class MUnvHexaBrickEleDataExportorImpl: public MUnvHexaBrickEleDataExportorInterface
  {
  public:
    MUnvHexaBrickEleDataExportorImpl();
    /*
     * 析构函数，仅为类继承关系而设置
     */
    virtual ~MUnvHexaBrickEleDataExportorImpl();

  public:
    /*
     * 初始化
     */
    bool initialize(MDataModel& model, bool isRepeated);

    /**
     * 取进度监视对象
     */
    ProgressMonitor getProgressMonitor() const;

    /*
     * 根据文件名导出数据
     */
    bool dataExport(QTextStream* stream, const QString& name);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MUNVHEXABRICKELEDATAEXPORTORIMPL_H_ */
