#include <org.sipesc.fems.example.h>
#include <mobjectmanager.h>
#include <org.sipesc.core.engdbs.data.mdatafactorymanager.h>
#include <mhexabrickelementdataimpl.h>

#include <mchexahandlerimpl.h>
#include <mchexahandlerfactoryimpl.h>

#include <mhexabrickelestiffcalculatorfactoryimpl.h>
#include <mbrickeleconstidparserimpl.h>
#include <mbrickeleconstidparserfactoryimpl.h>
#include <mhexabrickstrainmatriximpl.h>
#include <mhexabrickstrainmatrixfactoryimpl.h>
#include <mhexashpfunctionimpl.h>
#include <mhexashpfunctionfactoryimpl.h>
#include <mgau3d2integformimpl.h>
#include <mgau3d2integformfactoryimpl.h>
#include <mgau3dintegformimpl.h>
#include <mgau3dintegformfactoryimpl.h>

#include <mhexabrickelestraincalculatorfactoryimpl.h>
#include <mhexabrickelestresscalculatorfactoryimpl.h>
#include <mhexabricknodestresscalculatorimpl.h>
#include <mhexabricknodestresscalculatorfactoryimpl.h>

#include <mhexabrickelemasscalculatorfactoryimpl.h>
#include <mhexabricklumpedmassmatriximpl.h>
#include <mhexabricklumpedmassmatrixfactoryimpl.h>

#include <mhexabrickelevolumefactoryimpl.h>
#include <mhexabrickelevolumeimpl.h>

#include <munvhexabrickeledataexportorimpl.h>
#include <munvhexabrickeledataexportorfactoryimpl.h>

//#include <mhexa185brickelementdataimpl.h>
//#include <machexa185handlerimpl.h>
//#include <machexa185handlerfactoryimpl.h>
//#include <mhexa185brickelestiffcalculatorfactoryimpl.h>
//#include <mhexa185brickstrainmatriximpl.h>
//#include <mhexa185brickstrainmatrixfactoryimpl.h>
//#include <mhexa185brickelestraincalculatorfactoryimpl.h>
//
//#include<m20brickeleconstidparserfactoryimpl.h>
//#include<m20brickeleconstidparserimpl.h>
//#include<mchexa20bdfhandlerfactoryimpl.h>
//#include<mchexa20bdfhandlerimpl.h>
//#include<mchexa20cdbhandlerfactoryimpl.h>
//#include<mchexa20cdbhandlerimpl.h>
//#include<melementdataimpl.h>
//#include<mgau3d3integformfactoryimpl.h>
//#include<mgau3d3integformimpl.h>
//#include<mhexa20brickelemasscalculatorfactoryimpl.h>
//#include<mhexa20brickelementdataimpl.h>
//#include<mhexa20brickelestiffcalculatorfactoryimpl.h>
//#include<mhexa20brickelestraincalculatorfactoryimpl.h>
//#include<mhexa20brickelestresscalculatorfactoryimpl.h>
//#include<mhexa20brickelevolumefactoryimpl.h>
//#include<mhexa20brickelevolumeimpl.h>
//#include<mhexa20bricklumpedmassmatrixfactoryimpl.h>
//#include<mhexa20bricklumpedmassmatriximpl.h>
//#include<mhexa20bricknodestresscalculatorfactoryimpl.h>
//#include<mhexa20bricknodestresscalculatorimpl.h>
//#include<mhexa20brickstrainmatrixfactoryimpl.h>
//#include<mhexa20brickstrainmatriximpl.h>
//#include<mhexa20shpfunctionfactoryimpl.h>
//#include<mhexa20shpfunctionimpl.h>
//#include<munvhexa20brickeledataexportorfactoryimpl.h>
//#include<munvhexa20brickeledataexportorimpl.h>

#include <mghexabricknodestresscalculatorimpl.h>
#include <mghexabricknodestresscalculatorfactoryimpl.h>
#include <mbrickelestiffbuilderimpl.h>

OrgSipescFemsExamplePlugin::OrgSipescFemsExamplePlugin()
  {
  _running = false;
  }

OrgSipescFemsExamplePlugin::~OrgSipescFemsExamplePlugin()
  {
  }

bool OrgSipescFemsExamplePlugin::initialize()
  {
  return true;
  }

bool OrgSipescFemsExamplePlugin::cleanup()
  {
  return true;
  }

void OrgSipescFemsExamplePlugin::start()
  {
  if (_running)
    return;

  MObjectManager objectManager = MObjectManager::getManager();
  MDataFactoryInterface* dataImpl;
  QString name = "org.sipesc.core.engdbs.mdatafactorymanager";
  MDataFactoryManager factoryManager = objectManager.getObject(name);

  name = "org.sipesc.fems.data.hexabrickelementdata";
  dataImpl = new MHexaBrickElementDataFactoryImpl;
  factoryManager.registerFactory(name, MDataFactory(dataImpl));

//  name = "org.sipesc.fems.data.hexa185brickelementdata";
//  dataImpl = new MHexa185BrickElementDataFactoryImpl;
//  factoryManager.registerFactory(name, MDataFactory(dataImpl));
//
//  name = "org.sipesc.fems.data.hexa20brickelementdata";
//  dataImpl = new MHexa20BrickElementDataFactoryImpl;
//  factoryManager.registerFactory(name, MDataFactory(dataImpl));

  _running = true;
  }

void OrgSipescFemsExamplePlugin::stop()
  {
  if (!_running)
    return;

  MObjectManager objectManager = MObjectManager::getManager();
  MDataFactoryInterface* dataImpl;
  QString name = "org.sipesc.core.engdbs.mdatafactorymanager";
  MDataFactoryManager factoryManager = objectManager.getObject(name);

  name = "org.sipesc.fems.data.hexabrickelementdata";
  factoryManager.unregisterFactory(name);

//  name = "org.sipesc.fems.data.hexa185brickelementdata";
//  factoryManager.unregisterFactory(name);
//
//  name = "org.sipesc.fems.data.hexa20brickelementdata";
//  factoryManager.unregisterFactory(name);

  _running = false;
  }

QStringList OrgSipescFemsExamplePlugin::getRequiredFeatures() const
  {
  QStringList result;
  result.append(QLatin1String("org.sipesc.fems.bdfimport"));
  result.append(QLatin1String("org.sipesc.utilities"));
  result.append(QLatin1String("org.sipesc.fems.element"));
  result.append(QLatin1String("org.sipesc.fems.stress"));
  result.append(QLatin1String("org.sipesc.fems.mass"));
  result.append(QLatin1String("org.sipesc.fems.jfxexport"));
  result.append(QLatin1String("org.sipesc.fems.cdbimport"));
  result.append(QLatin1String("org.sipesc.fems.femsutils"));
  return result;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXAHandler()
  {
  return new MCHEXAHandlerImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMBrickEleConstiDParser()
  {
  return new MBrickEleConstiDParserImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickStrainMatrix()
  {
  return new MHexaBrickStrainMatrixImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaShpFunction()
  {
  return new MHexaShpFunctionImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3D2IntegForm()
  {
  return new MGau3D2IntegFormImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3D2IntegFormFactory()
  {
  return new MGau3D2IntegFormFactoryImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3DIntegForm()
  {
  return new MGau3DIntegFormImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3DIntegFormFactory()
  {
  return new MGau3DIntegFormFactoryImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickNodeStressCalculator()
  {
  return new MHexaBrickNodeStressCalculatorImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickLumpedMassMatrix()
  {
  return new MHexaBrickLumpedMassMatrixImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleVolume()
  {
  return new MHexaBrickEleVolumeImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMUnvHexaBrickEleDataExportor()
  {
  return new MUnvHexaBrickEleDataExportorImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXAHandlerFactory()
  {
  return new MCHEXAHandlerFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleStiffCalculatorFactory()
  {
  return new MHexaBrickEleStiffCalculatorFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMBrickEleConstiDParserFactory()
  {
  return new MBrickEleConstiDParserFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickStrainMatrixFactory()
  {
  return new MHexaBrickStrainMatrixFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaShpFunctionFactory()
  {
  return new MHexaShpFunctionFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleStrainCalculatorFactory()
  {
  return new MHexaBrickEleStrainCalculatorFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleStressCalculatorFactory()
  {
  return new MHexaBrickEleStressCalculatorFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickNodeStressCalculatorFactory()
  {
  return new MHexaBrickNodeStressCalculatorFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleMassCalculatorFactory()
  {
  return new MHexaBrickEleMassCalculatorFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickLumpedMassMatrixFactory()
  {
  return new MHexaBrickLumpedMassMatrixFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexaBrickEleVolumeFactory()
  {
  return new MHexaBrickEleVolumeFactoryImpl;
  }

MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMUnvHexaBrickEleDataExportorFactory()
  {
  return new MUnvHexaBrickEleDataExportorFactoryImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMACHEXA185Handler()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMACHEXA185HandlerFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa185BrickEleStiffCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa185BrickStrainMatrix()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa185BrickStrainMatrixFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa185BrickEleStrainCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXA20BDFHandler()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXA20BDFHandlerFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickStrainMatrix()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20ShpFunction()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickStrainMatrixFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20ShpFunctionFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3D3IntegForm()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGau3D3IntegFormFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementM20BrickEleConstiDParser()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleStiffCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementM20BrickEleConstiDParserFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickNodeStressCalculator()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickLumpedMassMatrix()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleVolume()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMUnvHexa20BrickEleDataExportor()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleStrainCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleStressCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickNodeStressCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleMassCalculatorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickLumpedMassMatrixFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMHexa20BrickEleVolumeFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMUnvHexa20BrickEleDataExportorFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXA20CDBHandler()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMCHEXA20CDBHandlerFactory()
  {
  return 0;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGHexaBrickNodeStressCalculator()
  {
  return new MGHexaBrickNodeStressCalculatorImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMGHexaBrickNodeStressCalculatorFactory()
  {
  return new MGHexaBrickNodeStressCalculatorFactoryImpl;
  }
MExtensionObject* OrgSipescFemsExamplePlugin::createOrgSipescFemsHexaelementMBrickEleStiffBuilder()
  {
  return new MBrickEleStiffBuilderImpl;
  }
